exports.install = function(framework) {
    framework.route('/', view_logged, ['authorize']);
    framework.route('/', view_homepage);
    framework.route('/', json_homepage, ['xhr', 'post']);
    framework.route('/logout/', logout, ['authorize', 'get']);

    framework.route('/users', view_users, ['authorize','!admin']);
    framework.route('/userslist', view_userslist, ['authorize','!moderator']);
    framework.route('/mr', view_multiroles, ['authorize','!admin','!moderator']);
};

function view_logged() {
	var self = this;
	self.plain('You are logged as {0}. To unlogged remove cookie __user or click http://{1}:{2}/logout/');//.format(self.user.id, self.framework.ip, self.framework.port));
}

function view_homepage() {
	var self = this;
	self.view('homepage', { LoginName: '@' });
}

function view_userslist() {
    var self = this;
    self.plain('moderator.');
}

function view_multiroles() {
    var self = this;
    self.plain('multiple rules, but not all aithorized');
}

function json_homepage() {

	var self = this;
	var errorBuilder = self.validate(self.post, ['LoginName', 'LoginPassword']);

	if (errorBuilder.hasError()) {
		self.json(errorBuilder);
		return;
	}

    var connection = self.database();
    connection.connect(function(err){ if(err != null) { self.view500(err); return; }
        connection.query('SELECT * FROM users',function(err, o) {
           if (err != null) { self.view500(err); }
           else
            for(var i=0;i<o.rowCount;i++)
            if(o.rows[i].email === self.post.LoginName && o.rows[i].pswd === self.post.LoginPassword){
              self.res.cookie(self.config.cookie, self.framework.encrypt({ id: o.rows[i].idusr, roles: o.rows[i].roles, ip: self.req.ip }, 'user'), new Date().add('m', 5));
              self.json({ r: true });
            }
            connection.end();
        });
    });
}

function logout() {
	var self = this;
	self.res.cookie(self.config.cookie, '', new Date().add('y', -1));
	self.redirect('/');
}

function view_users() {

    var self = this;
    var connection = self.database();

    connection.connect(function(err){ if(err != null) { self.view500(err); return; }
        connection.query('SELECT * FROM users', function(err, rows) {
            if (err != null) { self.view500(err); }
            else { /* console.log(rows); */ }
            connection.end();
            self.view('users', rows);
        });
    });
}