// ================================================
// AUTHORIZATION
// ================================================

framework.onAuthorization = function(req, res, flags, callback) {

	var self = this;

	var cookie = req.cookie(self.config.cookie);
	if (cookie === null || cookie.length < 10) {
		callback(false);
		return;
	}

	var obj = self.decrypt(cookie, 'user');

	if (obj === null || obj === '' || obj.ip !== req.ip) {
		callback(false);
		return;
	}

	var user = self.cache.read('user_' + obj.id);
	if (user !== null) {
		req.user = user;
		callback(true);
		return;
	}

	var user = obj || null;
	if (user != null)
            	self.cache.add('user_'+user.id,user,new Date().add('minute',5));
            callback(user != null,user);
};

framework.on('controller', function(self, name) {

    var user = self.user;
    var approve = 0;
    console.log('user ',user);
    if (user === null)
        return;

      if (self.flags.indexOf('authorize') === -1)
        return;

    var roleFlagExist = 0;
    for (var i=0;i<self.flags.length;i++) if (self.flags[i].substring(0,1)=="!") roleFlagExist = 1;

    if(roleFlagExist == 1)
    {
    var length = user.roles.split(',').length;
    var roles = user.roles.split(',');
    for (var i = 0; i < length; i++) {
        var role = '!' + roles[i];
        if (self.flags.indexOf(role) !== -1) approve =1;
    }
    if(approve == 1)return;
    else
        {
	    self.cancel();
    	self.plain('YOU DO NOT HAVE A PERMISSION.');
        return;
        }
    }
});

framework.onValidation = function(name, value) {
	switch (name) {
		case 'LoginName':
			return utils.isEmail(value);
		case 'LoginPassword':
			return value.length > 0;
	};
}